// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

// Es fehlen die rhythmisch versetzten Kanons
// Es fehlen die Untersuchungen mit drei Zeitpositionen

#include <iostream>
#include <fstream>
using namespace std;

#include "klang.h"
#include "klangfolge.h"

int main()
{
    ofstream out("kombinationen.txt");

    int instrumente_laenge = 2;
    int instrumente_klaenge[] = {klang::d_akkord, klang::d_akkord};
    klangfolge instrumente(instrumente_laenge, instrumente_klaenge, "Instrumente");

    int instrumente_mit_h_laenge = 2;
    int instrumente_mit_h_klaenge[] = {klang::d_akkord, klang::h_akkord | klang::g_akkord};
    klangfolge instrumente_mit_h(instrumente_mit_h_laenge, instrumente_mit_h_klaenge, "Instrumente_Mit_H");

    int instrumente_mit_a_laenge = 2;
    int instrumente_mit_a_klaenge[] = {klang::d_akkord, klang::d_akkord | klang::h_akkord};
    klangfolge instrumente_mit_a(instrumente_mit_a_laenge, instrumente_mit_a_klaenge, "Instrumente_Mit_A");

    int kanon_1_3_3_laenge = 2;
    int kanon_1_3_3_klaenge[] = {klang::d_akkord | klang::h_akkord, klang::d_akkord | klang::h_akkord | klang::g_akkord};
    klangfolge kanon_1_3_3(kanon_1_3_3_laenge, kanon_1_3_3_klaenge, "Kanon 1 3 3");

    int kanon_3_1_3_laenge = 2;
    int kanon_3_1_3_klaenge[] = {klang::d_akkord | klang::h_akkord, klang::h_akkord | klang::g_akkord};
    klangfolge kanon_3_1_3(kanon_3_1_3_laenge, kanon_3_1_3_klaenge, "Kanon 3 1 3");

    int kanon_3_3_1_laenge = 2;
    int kanon_3_3_1_klaenge[] = {klang::d_akkord | klang::h_akkord, klang::h_akkord | klang::g_akkord | klang::e_akkord};
    klangfolge kanon_3_3_1(kanon_3_3_1_laenge, kanon_3_3_1_klaenge, "Kanon 3 3 1");

    int kanon_versetzt_1_3_3_laenge = 2;
    int kanon_versetzt_1_3_3_klaenge[] = {klang::d_akkord | klang::h_akkord | klang::g_akkord, klang::g_akkord | klang::e_akkord};
    klangfolge kanon_versetzt_1_3_3(kanon_versetzt_1_3_3_laenge, kanon_versetzt_1_3_3_klaenge, "Kanon_Versetzt 1 3 3");

    int kanon_versetzt_3_1_3_laenge = 2;
    int kanon_versetzt_3_1_3_klaenge[] = {klang::h_akkord | klang::g_akkord, klang::g_akkord | klang::e_akkord};
    klangfolge kanon_versetzt_3_1_3(kanon_versetzt_3_1_3_laenge, kanon_versetzt_3_1_3_klaenge, "Kanon_Versetzt 3 1 3");

    int kanon_versetzt_3_3_1_laenge = 2;
    int kanon_versetzt_3_3_1_klaenge[] = {klang::h_akkord | klang::g_akkord | klang::e_akkord, klang::g_akkord | klang::e_akkord};
    klangfolge kanon_versetzt_3_3_1(kanon_versetzt_3_3_1_laenge, kanon_versetzt_3_3_1_klaenge, "Kanon_Versetzt 3 3 1");

    instrumente.teste_kombinationen_mit(out, kanon_1_3_3);
    instrumente.teste_kombinationen_mit(out, kanon_3_1_3);
    instrumente.teste_kombinationen_mit(out, kanon_3_3_1);

    instrumente_mit_h.teste_kombinationen_mit(out, kanon_1_3_3);
    instrumente_mit_h.teste_kombinationen_mit(out, kanon_3_1_3);
    instrumente_mit_h.teste_kombinationen_mit(out, kanon_3_3_1);

    instrumente_mit_a.teste_kombinationen_mit(out, kanon_1_3_3);
    instrumente_mit_a.teste_kombinationen_mit(out, kanon_3_1_3);
    instrumente_mit_a.teste_kombinationen_mit(out, kanon_3_3_1);

    instrumente.teste_kombinationen_mit(out, kanon_versetzt_1_3_3);
    instrumente.teste_kombinationen_mit(out, kanon_versetzt_3_1_3);
    instrumente.teste_kombinationen_mit(out, kanon_versetzt_3_3_1);

    instrumente_mit_h.teste_kombinationen_mit(out, kanon_versetzt_1_3_3);
    instrumente_mit_h.teste_kombinationen_mit(out, kanon_versetzt_3_1_3);
    instrumente_mit_h.teste_kombinationen_mit(out, kanon_versetzt_3_3_1);

    instrumente_mit_a.teste_kombinationen_mit(out, kanon_versetzt_1_3_3);
    instrumente_mit_a.teste_kombinationen_mit(out, kanon_versetzt_3_1_3);
    instrumente_mit_a.teste_kombinationen_mit(out, kanon_versetzt_3_3_1);

    return 0;
}
