// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
#include "StdAfx.h"
#include "folge.h"

folge::folge(int laenge, int* inhalt)
{
    m_laenge = laenge;
    if(m_laenge == 0)
    {
	m_inhalt = NULL;
	return;
    }
    m_inhalt = new int [m_laenge];
    if(m_inhalt == NULL)
	exit(1);
//Laenge angegeben, aber kein Inhalt, Initialisierung mit 0
    if(inhalt == NULL)
	for(int i = 0; i < m_laenge; i++)
	    m_inhalt[i] = 0;
    else
	for(int i = 0; i < m_laenge; i++)
	    m_inhalt[i] = inhalt[i];
}

folge::~folge()
{
    delete[] m_inhalt;
}

folge::folge(const folge& ausgangsfolge)
{
    m_laenge = ausgangsfolge.m_laenge;
    if(m_laenge == 0)
    {
	m_inhalt = NULL;
	return;
    }
    m_inhalt = new int [m_laenge];
    if(m_inhalt == NULL)
	exit(1);
    for(int i = 0; i < m_laenge; i++)
	m_inhalt[i] = ausgangsfolge.m_inhalt[i];
}

folge& folge::operator=(const folge& ausgangsfolge)
{
    if(this == &ausgangsfolge)
	return *this;
    delete[] m_inhalt;
    m_laenge = ausgangsfolge.m_laenge;
    if(m_laenge == 0)
    {
	m_inhalt = NULL;
	return *this;
    }
    m_inhalt = new int [m_laenge];
    if(m_inhalt == NULL)
	exit(1);
    for(int i = 0; i < m_laenge; i++)
	m_inhalt[i] = ausgangsfolge.m_inhalt[i];
    return *this;
}

void folge::setze(int wert, int position)
{
    m_inhalt[position] = wert;
}

int folge::get_mittelposition() const
{
    int hoechster_ton;
    int tiefster_ton;

    tiefster_ton = hoechster_ton = m_inhalt[0];

    for(int i = 1; i < m_laenge; i++)
    {
	if(m_inhalt[i] < tiefster_ton)
	    tiefster_ton = m_inhalt[i];
	else if(m_inhalt[i] > hoechster_ton)
	    hoechster_ton = m_inhalt[i];
    }

    return (tiefster_ton + hoechster_ton) / 2;
}
