// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
// kgra_windows.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"

// KGRA.cpp
// Es knnte ein Fehler sein, Sackgassen durch klasse zu markieren, da klasse dadurch im Laufe des Programms zwei Bedeutungen bekommt

#include	<iostream>
#include	<fstream>
#include	<cstdlib>
#include	<string>
using namespace std;

/* Einstiege */
/* Parallelenverbot abschaltbar */
/* Quart als Dissonanz abschaltbar */

#define ERR            0
#define NOERR          1
#define UNGLEICH       0
#define GLEICH         1
#define MAXKNOT        2000
#define MAXLIST        4000
#define HOECHST        35
#define TIEFST         -35
#define MAXSTIM        5
#define MAXTIEF        20
#define PAUSE          -0x8000
#define ANFANGSTON     0
#define ANFANG         0
#define DISS           0
#define KONS           1

  // Quarten zum Bass gelten als dissonant
#define	KORRQUART		2

#define PRIM           0
#define QUART          3
#define QUINT          4
#define OKTAV          7
#define MIT_PARALL     0
#define OHNE_PARALL    1
#define BIT_DREIKLANG  21
#define BIT_OBEROKTAV  0x3f80
#define BIT_UNTEROKTAV 0x7f

struct  liste
  {
  struct  knoten  *kn;
  struct  liste   *folg;
  };

struct  knoten
  {
  int             ivl;
  int             nummer;
  struct  knoten  *klasse;
  struct  liste   *adj;
  struct  liste   *inz;
  };

int satz[MAXSTIM][MAXTIEF];
int anz_lst;
int anz_knt;
int kont_lst;
int kont_knt;
struct  liste *lstr;
struct  knoten *kntr;
int maxabst;
int maxsprung;
int kanon_tiefe;
int unters_tiefe;
int anz_stim;
int i_abs[MAXSTIM];
int r_abs[MAXSTIM];
int schritte[MAXTIEF / 2];
int weg[MAXTIEF / 2];
char  *ivl_name[] = {"Prim", "Sekund", "Terz", "Quart", "Quint", 
                    "Sext", "Septim", "Oktav"};
int anzahl_nicht_stille_knoten;
ofstream	fp;

struct  knoten wurzel;

int	parallelen(int * vh, int * nh, int n);
int	bass_quart(int * v, int n);
int	kons(int * v, int n);
void	schrittfolge();
struct  knoten *suche(struct  knoten *k, int *v, int n);

int	quart_flag; // speichert die Information darber, ob Quarten zum Bass 
				// als konsonant oder als dissonant gelten.

bool sackgassen_entfernen_flag; // speichert, ob Sackgassen entfernt werden sollen

struct  liste *g_lst()
{
  if(anz_lst < MAXLIST)
    return(lstr + anz_lst++);
  kont_lst = ERR;
  printf("Arbeitsspeicher reicht nicht!\n");
  return(NULL);
}

struct  knoten  *g_knt()
{
  if(anz_knt < MAXKNOT)
    return(kntr + anz_knt++);
  kont_knt = ERR;
  printf("Arbeitsspeicher reicht nicht!\n");
  return(NULL);
}

void eintragen(int *v, struct  knoten  *k, int t)
{
  struct liste *l, *g_lst();
  struct knoten  *k1, *g_knt();

  l = k->adj;
  while(l != NULL && (l->kn)->ivl != *v)
    l = l->folg;
  if(l == NULL)
    {
    l = g_lst();
    if(l != NULL)
      {
      l->folg = k->adj;
      k->adj = l;
      k1 = l->kn = g_knt();
      if(k1 != NULL)
        {
        k1->ivl = *v;
		k->inz = NULL;
        k1->klasse = NULL;
        k1->adj = NULL;
        if(t < kanon_tiefe - 1)
          eintragen(v + 1, k1, t + 1);
        }
      }
    }
  else /* (l->kn)->ivl == *v */
    {
    if(t < kanon_tiefe - 1)
      eintragen(v + 1, l->kn, t + 1);
    }
  return;
}

int betrag(int x)
{
  if(x < 0)
    return(-x);
  return(x);
}

int	zahlein(int *zahl, int min, int max)
{
  do
    {
	cin >> *zahl;
    if(*zahl > max)
      cout << "Eingabe zu gro" << endl;
    else if(*zahl < min)
      cout << "Eingabe zu klein" << endl;
    }
  while(*zahl > max || *zahl < min);
  return(NOERR);
}

void kanon_schema()
{
  int i, flag, letztmoeglich;
  char  c;

  letztmoeglich = (MAXTIEF - 1) / 2;
  maxabst = 0;
  i_abs[0] = 0;
  r_abs[0] = 0;
  cout << "Eingabe 2. Stimme" << endl;
  do
    cout << "Rhythmischer Einsatzabstand" << endl;
  while(zahlein(r_abs + 1, 0, letztmoeglich) == ERR);
  if(r_abs[1] > maxabst)
    maxabst = r_abs[1];
  do
    cout << "Intervallischer Einsatzabstand" << endl;
  while(zahlein(i_abs + 1, TIEFST, HOECHST) == ERR);
  for(flag = 1, i = 2; i < MAXSTIM && flag; i++)
    {
    do
      {
      cout << "Eingabe " << i + 1 <<". Stimme? (j/n)" << endl;
      cin >> c;
      }
    while(c != 'j' && c != 'J' && c != 'n' && c != 'N');
    if(c == 'j' || c == 'J')
      {
      do
        cout << "Rhythmischer Einsatzabstand" << endl;
      while(zahlein(r_abs + i, 0, letztmoeglich) == ERR);
      if(r_abs[i] > maxabst)
        maxabst = r_abs[i];
      do
        cout << "Intervallischer Einsatzabstand" << endl;
      while(zahlein(i_abs + i, TIEFST, HOECHST) == ERR);
      }
    else
      flag = 0;
    }
  if(flag == 1)
    anz_stim = MAXSTIM;
  else
    anz_stim = i - 1;

  // Quarten zum Bass
  do
  {
	  cout << "Sollen Quarten zum Bass dissonant sein? (j/n)" << endl;
	  cin >> c;
  }
  while(c != 'j' && c != 'J' && c != 'n' && c != 'N');

	if(c == 'j' || c == 'J')
		quart_flag = KORRQUART;
	else
		quart_flag = KONS;
  return;
}

void	weite()
{
  do
    cout << "Groesster Sprung?" << endl;
  while(zahlein(&maxsprung, 1, 7) == ERR);
	return;
}

void sollen_sackgassen_entfernt_werden()
{
    char c;
// Hier wird gefragt, ob Sackgassen entfernt werden sollen
  do
  {
	  cout << "Sollen Sackgassen entfernt werden? (j/n)" << endl;
	  cin >> c;
  }
  while(c != 'j' && c != 'J' && c != 'n' && c != 'N');

	if(c == 'j' || c == 'J')
		sackgassen_entfernen_flag = true;
	else
		sackgassen_entfernen_flag = false;
}

int pitch_class(int t)
{
  if(t < 0)
    return(6 - ((-1 - t) % 7));
  return(t % 7);
}

int	prf_parallelen(int z)
{
  int i;
  int akkord1[MAXSTIM];
  int akkord2[MAXSTIM];
  for(i = 0; i < anz_stim; i++)
    akkord1[i] = satz[i][z];
    for(i = 0, z--; i < anz_stim; i++)
      akkord2[i] = satz[i][z];
    return(parallelen(akkord2, akkord1, anz_stim));
}

int	parallelen(int * vh, int * nh, int n)
{
  int i, j, ivl, ni, vi, nj;
  for(i = 0; i < n - 1; i++)
    {
    if((ni = nh[i]) != PAUSE && (vi = vh[i]) != PAUSE)
      if(ni != vi)
        for(j = i + 1; j < n; j++)
          {
          if((nj = nh[j]) != PAUSE)
            if((ivl = (betrag(ni - nj) % 7)) == QUINT || ivl == PRIM)
              if(ni - nj == vi - vh[j])
                return(MIT_PARALL);
          }
    }
  return(OHNE_PARALL);
}

int	prf_bass_quart(int z)
{
  int i;
  int akkord1[MAXSTIM];
  for(i = 0; i < anz_stim; i++)
    akkord1[i] = satz[i][z];
  return(bass_quart(akkord1, anz_stim));
}

int	bass_quart(int * v, int n)
{
  int bs_ton, akk, i, t;

  for(akk = i = 0, bs_ton = PAUSE; i < n; i++)
    {
    if((t = v[i]) != PAUSE)
      {
      if(bs_ton == PAUSE || bs_ton > t)
        bs_ton = t;
      akk |= (1 << pitch_class(t));
      }
    }
  if(akk == 0)
    return(KONS);
  return(((1 << pitch_class(bs_ton + QUART)) & akk) != 0 ? DISS : KONS);
}

int	prf_kons(int z)
{
  int i;
  int akkord1[MAXSTIM];
  for(i = 0; i < anz_stim; i++)
    akkord1[i] = satz[i][z];
  return(kons(akkord1, anz_stim));
}

int	kons(int * v, int n)
{
  int pc, dr, kons_grad;
  for(kons_grad = 0x7f; kons_grad != 0 && n > 0; n--, v++)
    if(*v != PAUSE)
      {
      pc = pitch_class(*v);
      if((dr = BIT_DREIKLANG << pc) > BIT_UNTEROKTAV)
        dr = ((BIT_OBEROKTAV & dr) >> 7) | (BIT_UNTEROKTAV & dr);
      kons_grad &= dr;
      }
  return(kons_grad != 0 ? KONS : DISS);
}

void	setze(int t, int z)
{
  int i;
  for(i = 0; i < anz_stim; i++)
    {
    if(t != PAUSE)
      satz[i][z + r_abs[i]] = t + i_abs[i];
    else
      satz[i][z + r_abs[i]] = PAUSE;
    }
  return;
}

void versuche(int n)
{
  int t, o_gr, i;

  if(n == 0)
    {
    setze(ANFANGSTON, ANFANG);
    versuche(1);
    }
  else 
    {
    o_gr = satz[0][n - 1] + maxsprung;
    for(t = satz[0][n - 1] - maxsprung; t <= o_gr; t++)
      {
      setze(t, n);
      if(
		  prf_kons(n) == KONS && 
		  (quart_flag != KORRQUART || prf_bass_quart(n) == KONS) && 
		  prf_parallelen(n) == OHNE_PARALL
		  )
        {
        if(n < kanon_tiefe && kont_knt == NOERR && kont_lst == NOERR)
          versuche(n + 1);
        else
          {
          i = n + 1;
          while(i <= unters_tiefe && prf_kons(i) == KONS && prf_parallelen(i) == OHNE_PARALL)
            i++;
          if(i > unters_tiefe)
            {
            schrittfolge();
            if(kont_knt == NOERR && kont_lst == NOERR)
              eintragen(schritte, &wurzel, 0);
            }
          }
        }
      setze(PAUSE, n);
      }
    }
}

void schrittfolge()
{
  int i;
  for(i = 0; i <= kanon_tiefe; i++)
    schritte[i] = satz[0][i + 1] - satz[0][i];
}

struct  knoten *suche(struct  knoten *k, int *v, int n)
{
  struct  liste *l;
  l = k->adj;
  while(l != NULL && (l->kn)->ivl != *v)
    l = l->folg;
  if(l == NULL)
    return(NULL);
  if(n < kanon_tiefe - 2)
    return(suche(l->kn, v + 1, n + 1));
  return(l->kn);
}

void	alle_kinder(struct  knoten *k, int n)
{
  struct  knoten *k1;
  struct  liste *l, *g_lst();
  l = k->adj;
  while(l != NULL)
    {
    weg[n] = (l->kn)->ivl;
    if(n < kanon_tiefe - 1)
      alle_kinder(l->kn, n + 1);
    else
      {
      /* Knoten zum entsprechenden Endpunkt von weg + 1 */
      k1 = suche(&wurzel, weg + 1, 0);
      /* kopiere */
      if(k1 != NULL)
        (l->kn)->adj = k1->adj;
      }
    l = l->folg;
    }
	return;
}

int vergleiche(struct  knoten  *k1, struct  knoten  *k2, int t)
{
  int flag = 1;
  struct  liste *l1, *l2;
  if(k1->ivl != k2->ivl)
    return(UNGLEICH);
  if(t >= kanon_tiefe - 2)
    return(GLEICH);
  if(k1->adj == k2->adj)
    return(GLEICH);
  l1 = k1->adj;
  l2 = k2->adj;
  while(l1 != NULL && l2 != NULL)
    {
    if(vergleiche(l1->kn, l2->kn, t + 1) == UNGLEICH)
      return(UNGLEICH);
    l1 = l1->folg;
    l2 = l2->folg;
    }
  if(l1 != l2)
    return(UNGLEICH);
  return(GLEICH);
}

// Hier entsteht eine Inkosistenz
void	umschreiben(struct knoten *der_knoten)
{
  
    for(struct  liste *listenzeiger = der_knoten->adj; listenzeiger != NULL; listenzeiger = listenzeiger->folg)
	listenzeiger->kn = listenzeiger->kn->klasse;
    return;
}

void	inzidenzen(struct  knoten  *der_knoten)
{
  struct  liste *durchlaeufer, *hilfslistenelement;
  for(durchlaeufer = der_knoten->adj; durchlaeufer != NULL; durchlaeufer = durchlaeufer->folg)
    {
      hilfslistenelement = g_lst();
      if(hilfslistenelement == NULL)
      {
	  cout << "Zu wenig Speicherplatz fuer neues Listenelement" << endl;
	  exit(1);
      }
      hilfslistenelement->kn = der_knoten;
      if(durchlaeufer->kn == NULL) // Das duerfte nicht passieren; die Adjazenzliste ist inkosistent
	  cout << "Fehler: durchlaeufer->kn == NULL" << endl;
      hilfslistenelement->folg = durchlaeufer->kn->inz;
      durchlaeufer->kn->inz = hilfslistenelement; // Am Kopf einfuegen
    }
  return;
}

void	kgra_kopf(ostream& f)
{
  int i;
  f << "#Kanongraph zu folgendem Einsatzschema" << endl;
  f << "#Stimme\tRhythm. Abs.\tInterv.Abs" << endl;
  for(i = 0; i < anz_stim; i++)
      f << "#" << i + 1 << "\t" << r_abs[i] << "\t" << i_abs[i] << endl;
  f << "#Groesstmoeglicher Sprung: " << ivl_name[maxsprung] << endl;
  f << "#Quarte ";
    if(quart_flag == KONS)
      f << "generell als Konsonanz";
    else // quart_flag == KORRQUART
      f << "je nach Lage";
  f << endl;

  f << "#Maschinenlesbare Ausgabe des Kanonschemas" << endl;
  f << anz_stim << " #Anzahl der Stimmen" << endl;
  for(i = 0; i < anz_stim; i++)
      f << r_abs[i] << " " << i_abs[i] << endl;
	return;
}

void	kgraph(ostream& f)
{
  struct  knoten  *k, *ob_k;
  struct  liste     *l;
  int anzahl_adjazenzknoten = 0;
  f << "#Insgesamt " << anzahl_nicht_stille_knoten << " Knoten" << endl;
  f << "#Nummer" << "\t" << "Intervall" << "\t" << "Wohin" << "\t" << "Woher" << endl;
  for(ob_k = (k = kntr) + anz_knt; k < ob_k; k++)
    if(k == k->klasse)
      {
      f << "#";
      f << k->nummer << "\t";
      f << ivl_name[betrag(k->ivl)] << " ";
      if(k->ivl < 0)
        f << "abw. ";
      else if(k->ivl > 0)
        f << "aufw. ";
      f << "\t";
      for(l = k->adj; l != NULL; l = l->folg)
        f << (l->kn)->nummer << " ";
      f << "\t";
      for(l = k->inz; l != NULL; l = l->folg)
        f << (l->kn)->nummer << " ";
      f << endl;
      }
  f << "#Fuer die Berechnung: " << anz_knt << " Knoten " << anz_lst << " Kanten" << endl;
//Maschinenausgabe
  f << "#Maschinenlesbare Ausgabe" << endl;
  f << anzahl_nicht_stille_knoten << " #Anzahl der Knoten" << endl;
  f << "#Nummer" << "\t" << "Intervall" << "\t" << "Anzahl der Adjazenzen" << "\t" << "Wohin" << endl;
  for(ob_k = (k = kntr) + anz_knt; k < ob_k; k++)
    if(k == k->klasse)
      {
      f << k->nummer - 1 << " ";
      f << k->ivl << " ";
      for(l = k->adj, anzahl_adjazenzknoten = 0; l != NULL; l = l->folg, anzahl_adjazenzknoten++); // Anzahl der Adjazenzknoten bestimmen
      f << anzahl_adjazenzknoten << " ";
      for(l = k->adj; l != NULL; l = l->folg)
        f << (l->kn)->nummer - 1 << " ";
      f << endl;
      }
	return;
}

void	speichern()
{
  ofstream fp("graphendatei.txt");
  kgra_kopf(fp);
  kgraph(fp);
	return;
}

void entferne_sackgassen_aus_adjazenzliste(struct knoten* ein_knoten)
{
// while-Schleife, damit mehrfach der jeweils erste Knoten aus der Liste entfernt werden kann
    while(ein_knoten->adj != NULL && ein_knoten->adj->kn->klasse == NULL) // Prueft das erste Element der Liste
	ein_knoten->adj = ein_knoten->adj->folg;

    for(struct liste* listenzeiger = ein_knoten->adj; listenzeiger != NULL; listenzeiger = listenzeiger->folg)
	if(listenzeiger->folg != NULL && listenzeiger->folg->kn->klasse == NULL)
	    listenzeiger->folg = listenzeiger->folg->folg;
    return;
}

void sackgassen_loeschen()
{
    bool sackgasse_moeglich = true;
    while(sackgasse_moeglich == true)
    {
	bool sackgasse_gefunden = false;
	for(int i = 0; i < anz_knt; i++) // alle Knoten auf Sackgassen pruefen und entfernen
	    if(kntr[i].klasse == kntr + i && kntr[i].adj == NULL) // wenn Knoten nicht still gelegt und Adjazenzliste leer
	    {
		kntr[i].klasse = NULL; // Knoten als Sackgasse markieren: 
		sackgasse_gefunden = true;
	    }
	if(sackgasse_gefunden == false) // Wenn bei einem kompletten Durchgang durch alle Knoten keine Sackgassen mehr entdeckt worden sind,
	    sackgasse_moeglich = false; // enthaelt der Graph keine mehr
	else // Fuer alle Knoten Verweise auf sackgassen loeschen
	    for(int i = 0; i < anz_knt; i++) // alle Knoten auf Sackgassen pruefen und entfernen
		if(kntr[i].klasse == kntr + i && kntr[i].adj != NULL) // wenn Knoten nicht still gelegt und Adjazenzliste nicht leer
		    entferne_sackgassen_aus_adjazenzliste(&kntr[i]);
    }
    return;
}

void	kanon()
{
  int i, j, nr;
  char  c;
  anz_lst = 0;
  anz_knt = 0;
  kont_lst = NOERR;
  kont_knt = NOERR;
  for(i = 0; i < MAXLIST; i++)
  {
    lstr[i].kn = NULL;
	lstr[i].folg = NULL;
  }
  for(i = 0; i < MAXKNOT; i++)
  {
		kntr[i].klasse =  NULL;
		kntr[i].adj =  NULL;
		kntr[i].inz = NULL;
  }
  for(i = 0; i < MAXSTIM; i++)
    for(j = 0; j < MAXTIEF; j++)
      satz[i][j] = PAUSE;
  wurzel.adj = NULL;
  kanon_schema();
  weite();
  sollen_sackgassen_entfernt_werden();
  /* Eingabe der Konsonanzkriterien */
  kanon_tiefe = maxabst + 1;
  unters_tiefe = maxabst * 2;
  cout << "Untersuchung der Moeglichkeiten" << endl;
  versuche(ANFANG);
  /* Baum abschliessen */
  if(kont_knt == NOERR && kont_lst == NOERR)
    {
    alle_kinder(&wurzel, 0);
    /* Knoten in Konsequenzklassen einteilen */
    for(i = 0; i < anz_knt; i++)
      if(kntr[i].klasse == NULL)
        {
        kntr[i].klasse = kntr + i;
        for(j = i + 1; j < anz_knt; j++)
          if(kntr[j].klasse == NULL)
            if(vergleiche(kntr + i, kntr + j, 0) == GLEICH)
              kntr[j].klasse = kntr + i;
        }
    for(i =  0; i < anz_knt; i++)
      if(kntr[i].klasse == kntr + i)
	  umschreiben(kntr + i);

// Hier werden Sackgassen entfernt
    if(sackgassen_entfernen_flag == true)
    {
	cout << "Sackgassen werden entfernt" << endl;
	sackgassen_loeschen();
    }

    for(i =  anzahl_nicht_stille_knoten = 0; i < anz_knt; i++)
      if(kntr[i].klasse == kntr + i)
	  anzahl_nicht_stille_knoten++;

    cout << "Inzidenzlisten erstellen" << endl;

    for(i = 0; i < anz_knt; i++)
      if(kntr[i].klasse == kntr + i)
        inzidenzen(kntr + i);


    cout << "Umnummerieren" << endl;
    if(kont_lst == NOERR)
      {
      for(i = 0, nr = 1; i < anz_knt; i++)
        if(kntr[i].klasse == kntr + i)
          kntr[i].nummer = nr++;
      /* Ausgabe */
      kgra_kopf(cout);
      kgraph(cout);
      do
        {
        cout << "Graph abspeichern? (j/n)" << endl;
        cin >> c ;
        }
        while(c != 'j' && c != 'J' && c != 'n' && c != 'N');
      if(c == 'j' || c == 'J')
        speichern();
      }
    }
	return;
}

int _tmain(int argc, _TCHAR* argv[])
{
  char  c;
  // fp = NULL;
  
  // lstr = (struct liste *)calloc(MAXLIST, sizeof(struct liste));
  lstr = new struct liste[MAXLIST];

  // kntr = (struct knoten *)calloc(MAXKNOT, sizeof(struct knoten));
  kntr = new struct knoten[MAXKNOT];

  do
    {
    kanon();
    do
      {
      cout << "Neuer Kanon? (j/n)" << endl;
      cin >> c;
      }
      while(c != 'j' && c != 'J' && c != 'n' && c != 'N');
    }
    while(c == 'j' || c == 'J');

	delete[] lstr;
	delete[] kntr;

	return 0;
}

